.\" $XFree86: xc/programs/Xserver/hw/xfree86/drivers/trident/trident.man,v 1.14 2003/05/29 21:48:09 herrb Exp $ 
.\" shorthand for double quote that works everywhere.
.ds q \N'34'
.TH TRIDENT __drivermansuffix__ __vendorversion__
.SH NAME
trident \- Trident video driver
.SH SYNOPSIS
.nf
.B "Section \*qDevice\*q"
.BI "  Identifier \*q"  devname \*q
.B  "  Driver \*qtrident\*q"
\ \ ...
.B EndSection
.fi
.SH DESCRIPTION
.B trident
is an __xservername__ driver for Trident video cards.  The driver is 
accelerated, and provides support for the following framebuffer depths:
1, 4, 8, 15, 16, and 24. Multi-head configurations are supported.
The XvImage extension is supported on TGUI96xx and greater cards.
.SH SUPPORTED HARDWARE
The
.B trident
driver supports PCI,AGP and ISA video cards based on the following 
Trident chips:
.TP 12
.B Blade
Blade3D, CyberBlade series i1, i7 (DSTN), i1, i1 (DSTN), Ai1, Ai1 (DSTN),
CyberBlade/e4, CyberBladeXP, CyberBladeAi1/XP, BladeXP
.TP 12
.B Image
3DImage975, 3DImage985, Cyber9520, Cyber9525, Cyber9397, Cyber9397DVD
.TP 12
.B ProVidia
9682, 9685, Cyber9382, Cyber9385, Cyber9388
.TP 12
.B TGUI
9440AGi, 9660, 9680
.TP 12
.B ISA/VLBus
8900C, 8900D, 9000, 9200CXr, Cyber9320, 9400CXi, 9440AGi
These cards have been ported but need further testing and may not work.
.SH CONFIGURATION DETAILS
Please refer to __xconfigfile__(__filemansuffix__) for general configuration
details.  This section only covers configuration details specific to this
driver.
.PP
The following driver
.B Options
are supported:
.TP
.BI "Option \*qSWCursor\*q \*q" boolean \*q
Enable or disable the SW cursor.  Default: off.
.TP
.BI "Option \*qNoAccel\*q \*q" boolean \*q
Disable or enable acceleration.  Default: acceleration is enabled.
.TP
.BI "Option \*qPciRetry\*q \*q" boolean \*q
Enable or disable PCI retries.  Default: off.
.TP
.BI "Option \*qCyberShadow\*q \*q" boolean \*q
For Cyber chipsets only, turn off shadow registers. If you only see
a partial display - this may be the option for you. Default: on.
.TP
.BI "Option \*qCyberStretch\*q \*q" boolean \*q
For Cyber chipsets only, turn on stretching. When the resolution is lower
than the LCD's screen, this option will stretch the graphics mode to
fill the entire LCD. Default: off.
.TP
.BI "Option \*qShadowFB\*q \*q" boolean \*q
Enable or disable use of the shadow framebuffer layer.  Default: off.
.TP
.BI "Option \*qVideoKey\*q \*q" integer \*q
This sets the default pixel value for the YUV video overlay key.
Default: undefined.
.TP
.BI "Option \*qTVChipset\*q \*q" string \*q
This sets the TV chipset. Options are CH7005 or VT1621.
Default: off.
.TP
.BI "Option \*qTVSignal\*q \*q" integer \*q
This sets the TV signalling. Options are 0 for NTSC or 1 for PAL.
Default: undefined.
.TP
.BI "Option \*qNoPciBurst\*q \*q" boolean \*q
Turn off PCI burst mode, PCI Bursting is on by default.
Default: off.
.TP
.BI "Option \*qXvHsync\*q \*q" integer \*q
Override the default Horizontal-sync value for the Xv extension.
This is used to center the Xv image on the screen.  By default the values
are assigned based on the video card.
Default: 0.
.TP
.BI "Option \*qXvVsync\*q \*q" integer \*q
Override the default Vertical-sync value for the Xv extension.
This is used to center the Xv image on the screen.  By default the values
are assigned based on the video card.
Default: 0.
.TP
.BI "Option \*qXvBskew\*q \*q" integer \*q
Override the default Bottom skew value for the Xv extension.
This is used to extend the Xv image on the screen at the bottom.  By 
default the values are assigned based on the video card.
Default: 0.
.TP
.BI "Option \*qXvRskew\*q \*q" integer \*q
Override the default Right skew value for the Xv extension.
This is used to extend the Xv image on the screen at the right.  By 
default the values are assigned based on the video card.
Default: 0.
.TP
.BI "Option \*qDisplay\*q \*q" string \*q
Override the display.
Possible values are \*qCRT\*q, \*qLCD\*q and \*qDual\*q.
Please note that this option is only experimentally.
Default: Use display active when X started.
.TP
.BI "Option \*qDisplay1400\*q \*q" boolean \*q
Inform driver to expect 1400x1050 display instead of a 1280x1024.
Default: off.
.TP
.BI "Option \*qGammaBrightness\*q \*q" string \*q
Set display gamma value and brightness. \*q\fIstring\fP\*q is 
\*q\fIgamma\fP, \fIbrightness\fP\*q, where \fIgamma\fP is a floating 
point value greater than 0 and less or equal to 10. \fIbrightness\fP is 
an integer value greater or equal to 0 and less than 128. 
Default: gamma and brightness control is turned off. 
Note: This is not supported on all chipsets.
.SH "SEE ALSO"
__xservername__(__appmansuffix__), __xconfigfile__(__filemansuffix__), xorgconfig(__appmansuffix__), Xserver(__appmansuffix__), X(__miscmansuffix__)
.SH AUTHOR
Author: Alan Hourihane
